%% This script produces all figures and tables of the manuscript

clear variables;close all;clc
ini
disp(['Mean (SD) age = ' num2str(mean(Age)) ' (' num2str(std(Age)) ')'])
disp(['Min, Max age = ' num2str(min(Age)) ', ' num2str(max(Age))])
disp(['Nr females, Nr males = ' num2str(sum(Gender==1)) ', ' num2str(sum(Gender==2))])
disp(['Nr participants in good, windy, and bad weather = ' num2str(sum(Weather==1)) ', ' num2str(sum(Weather==2))  ', ' num2str(sum(Weather==3))])
[table_all1.lat,table_all1.long,table_all1.date,table_all1.kmh,table_all2.lat,table_all2.long,table_all2.date,table_all2.kmh]=deal(NaN);
load('20170222_140533_table.mat');table1=table; % load tables with data (Date, GPS, Speed) extracted from videos
load('20170308_145345_table.mat');table2=table; % load tables with data (Date, GPS, Speed) extracted from videos
[a,b,c]=xlsread('Times dashcam-speed analysis_checked.xlsx','A2:L493'); % Load coding tables from Ana

% initialize data
XDate=NaN(size(c,1),1);  % date
XPP  =NaN(size(c,1),1);  % participant number
XSC=cell(size(c,1),1);   % scenario code
XS   =NaN(size(c,1),1);  % 1 = not stopping, 2 = stopping, -1 = not tested
XLR  =NaN(size(c,1),1);  % 1 = approach from Left (from Exact building), 2 = approach from Right (from Aerospace building direction), -1 = not tested
TSTM =NaN(size(c,1),1);  % Time step backward (mid cam), - 1 = no step back (NSB), -2 = not tested (NT), -3 = video not available (VNA), -4 = participant not visible (PNV)
TSDL =NaN(size(c,1),1);  % Time start driving (left cam), - 1 = no step back (NSB), -2 = not tested (NT), -3 = video not available (VNA), -4 = participant not visible (PNV)
TSTL =NaN(size(c,1),1);  % Time step backward (left cam), - 1 = no step back (NSB), -2 = not tested (NT), -3 = video not available (VNA), -4 = participant not visible (PNV)
TENL =NaN(size(c,1),1);  % Time end of scenario (left cam), - 1 = no step back (NSB), -2 = not tested (NT), -3 = video not available (VNA), -4 = participant not visible (PNV)

for i=1:size(c,1); % process data from Excel file
    XDate(i)=datenum(cell2mat(c(i,1))); % date
    XPP(i)=cell2mat(c(i,2)); % participant number
    XSC(i)=c(i,3); % scenario code
    XS(i)=strcmp(c(i,5),'NS')*1+strcmp(c(i,5),'S')*2+strcmp(c(i,5),'NT')*-1; % 1 = not stopping, 2 = stopping, -1 = not tested
    XLR(i)=strcmp(c(i,6),'L')*1+strcmp(c(i,6),'R')*2+strcmp(c(i,6),'NT')*-1; % 1 = not stopping, 2 = stopping, -1 = not tested
    if ischar(cell2mat(c(i,8))); TSTM(i)=strcmp(cell2mat(c(i,8)),'NSB ')*-1 +strcmp(cell2mat(c(i,8)),'NSB')*-1 +strcmp(cell2mat(c(i,8)),'NT')*-2+strcmp(cell2mat(c(i,8)),'VNA')*-3+strcmp(cell2mat(c(i,8)),'PNV')*-4;else TSTM(i)=XDate(i)+cell2mat(c(i,8));end
    if ischar(cell2mat(c(i,9))); TSDL(i)=strcmp(cell2mat(c(i,9)),'NSB ')*-1 +strcmp(cell2mat(c(i,9)),'NSB')*-1 +strcmp(cell2mat(c(i,9)),'NT')*-2+strcmp(cell2mat(c(i,9)),'VNA')*-3+strcmp(cell2mat(c(i,9)),'PNV')*-4;else TSDL(i)=XDate(i)+cell2mat(c(i,9));end
    if ischar(cell2mat(c(i,10)));TSTL(i)=strcmp(cell2mat(c(i,10)),'NSB ')*-1+strcmp(cell2mat(c(i,10)),'NSB')*-1+strcmp(cell2mat(c(i,10)),'NT')*-2+strcmp(cell2mat(c(i,10)),'VNA')*-3+strcmp(cell2mat(c(i,10)),'PNV')*-4;else TSTL(i)=XDate(i)+cell2mat(c(i,10));end
    if ischar(cell2mat(c(i,11)));TENL(i)=strcmp(cell2mat(c(i,11)),'NSB ')*-1+strcmp(cell2mat(c(i,11)),'NSB')*-1+strcmp(cell2mat(c(i,11)),'NT')*-2+strcmp(cell2mat(c(i,11)),'VNA')*-3+strcmp(cell2mat(c(i,11)),'PNV')*-4;else TENL(i)=XDate(i)+cell2mat(c(i,11));end
end
TD=24*3600*(TSTM-TSTL); % time difference between mid camera and left camera (in seconds)
TD(abs(TD)>3000)=NaN;
TD(TSTM<0 | TSTL<0)=NaN;
t=1:numel(TD);TD = interp1(t(~isnan(TD)),TD(~isnan(TD)),t,'linear','extrap'); % interpolate NaNs of time difference vector
TD=movmean(TD,10)';
TSTL(TSTL==-4)=TSTM(TSTL==-4)-TD(TSTL==-4)/(24*3600); % impute left cam stepping back times from MID cam using time difference

for i=1:length(table1) % loop over all videos, and aggregate everything in table_all
    table1(i).lat= floor(table1(i).lat) + (table1(i).lat-floor(table1(i).lat))*10/6;
    table1(i).long= floor(table1(i).long)+ (table1(i).long-floor(table1(i).long))*10/6;
    table_all1.lat =[table_all1.lat table1(i).lat];
    table_all1.long=[table_all1.long table1(i).long];
    table_all1.date=[table_all1.date table1(i).date];
    table_all1.kmh =[table_all1.kmh table1(i).kmh];
end
for i=1:length(table2) % loop over all videos, and aggregate everything in table_all
    table2(i).lat  = floor(table2(i).lat) + (table2(i).lat-floor(table2(i).lat))*10/6;
    table2(i).long = floor(table2(i).long)+ (table2(i).long-floor(table2(i).long))*10/6;
    table_all2.lat =[table_all2.lat table2(i).lat];
    table_all2.long=[table_all2.long table2(i).long];
    table_all2.date=[table_all2.date table2(i).date];
    table_all2.kmh =[table_all2.kmh table2(i).kmh];
end

temp=find(round(diff(table_all1.date)*24*3600)==0);temp=[0 temp]; % remove duplicate frames
table_all1.lat(temp+1)=[];table_all1.long(temp+1)=[];table_all1.date(temp+1)=[];table_all1.kmh(temp+1)=[];
temp=find(round(diff(table_all2.date)*24*3600)==0);temp=[0 temp]; % remove duplicate frames
table_all2.lat(temp+1)=[];table_all2.long(temp+1)=[];table_all2.date(temp+1)=[];table_all2.kmh(temp+1)=[];

table_all.lat=[table_all1.lat table_all2.lat];    % merge the two tables (day 1 & day 2-4)
table_all.long=[table_all1.long table_all2.long]; % merge the two tables (day 1 & day 2-4)
table_all.date=[table_all1.date table_all2.date]; % merge the two tables (day 1 & day 2-4)
table_all.kmh=[table_all1.kmh table_all2.kmh];    % merge the two tables (day 1 & day 2-4)

INTR=5; % Interpolate the GPS data from 1 Hz to 5 Hz
date_i=table_all.date(1):1/(24*3600)/INTR:table_all.date(end);
date_i(date_i>table_all.date(14699)+0.01 & date_i < table_all.date(14700)-0.01)=[]; % remove some data where no driving occurs
date_i(date_i>table_all.date(34482)+0.01 & date_i < table_all.date(34483)-0.01)=[]; % remove some data where no driving occurs
date_i(date_i>table_all.date(54703)+0.01 & date_i < table_all.date(54704)-0.01)=[]; % remove some data where no driving occurs
table_all.lat=interp1(table_all.date,table_all.lat,date_i,'linear'); % interpolate table_all
table_all.long=interp1(table_all.date,table_all.long,date_i,'linear');
table_all.kmh=interp1(table_all.date,table_all.kmh,date_i,'linear');
table_all.date=interp1(table_all.date,table_all.date,date_i,'linear');

% End of Heertjeslaan = 51.986928, 4.376868 (from Google Maps)
% GPS coordinate of participant = Lat = 51.989892, Long = 4.387817 (from Ana)
DO2=deg2km(distance(51.986928, 4.376868, 51.989892, 4.387817),6371)*1000; % distance between end of Heertjeslaan and participant
D=deg2km(distance(table_all.lat,table_all.long,51.986928,4.376868),6371)*1000-DO2; % distance to end of Heertjeslaan minus distance between end of Heertjeslaan and start of Exact road
S=[diff(D)*3.6 NaN]*INTR; % calculated speed from travelled distance
%%
clear h
count=0;
figure;hold on
[T_Distance,T_Speed,T_Speed30m]=deal(NaN(size(XDate,1),1));
V=-200:1:200;
TT_S=NaN(size(XDate,1),length(V));
for i=1:size(XDate,1);
    if  TSTL(i)>0 % if approaching from right (from Aerospace building direction) and the participant steps back
        [~,b] =min(abs(TSDL(i)-table_all.date)); % find index of table_all (videos) where the driving starts (left cam)
        [~,b2]=min(abs(TENL(i)-table_all.date)); % find index of table_all (videos) where the driving ends (left cam)
        [~,b3]=min(abs(TSTL(i)-table_all.date)); % find index of table_all (videos) where the participant steps back (left cam)
        b3=b3-b+1; % moment that the participant steps back
        b4=round(8*INTR);b2=b2+b4; % add 8 seconds to end of video
        S2temp=table_all.kmh(b:b2); % km/h from video
        Stemp=S(b:b2); % km/h from start to end of video, derived by differentiating the distance; (negative sign is driving towards the Aerospace building direction)
        Dtemp=D(b:b2); % distance from start to end of video
        if XLR(i)==2 % if approaching from right (from Aerospace building direction)
            Dtemp=Dtemp+4; % correct for car length (4 m offset)
            b5a=length(S2temp)-b4-round(5*INTR)-2+find(Dtemp(end-b4-round(5*INTR):end)>0,1,'first'); % car passed pedestrian
            b5b=length(S2temp)-b4-round(5*INTR)-1+find(Stemp(end-b4-round(5*INTR):end)<=0.5,1,'first'); % find index where speed is 0 or car drives backward
            b5c=length(S2temp)-b4-round(5*INTR)-1+find(S2temp(end-b4-round(5*INTR):end)==0.0,1,'first'); % find index where speed is 0 or car drives backward
            b5=min([b5a b5b b5c]);
            if b5<b3;b5=b3;end % if cut before participant steps back, then end the sample at the moment the participant steps back
            Dtemp=Dtemp(1:b5);Stemp=S2temp(1:b5);S2temp=S2temp(1:b5);
            
            if XS(i)==1 % car does not stop
                plot(Dtemp,S2temp,'r','Linewidth',2)
            elseif XS(i)==2 % car stops
                plot(Dtemp,S2temp,'k','Linewidth',2)
            end
            
        elseif XLR(i)==1 % if approaching from left (from Exact building)
            Dtemp=Dtemp-4; % correct for car length
            b5a=length(S2temp)-b4-round(5*INTR)-2+find(Dtemp(end-b4-round(5*INTR):end)<0,1,'first'); % car passed pedestrian
            b5b=length(S2temp)-b4-round(5*INTR)-1+find(Stemp(end-b4-round(5*INTR):end)>=-0.5,1,'first'); % find index where speed is 0 or car drives backward
            b5c=length(S2temp)-b4-round(5*INTR)-1+find(S2temp(end-b4-round(5*INTR):end)==0.0,1,'first'); % find index where speed is 0 or car drives backward
            b5=min([b5a b5b b5c]);
            if b5<b3;b5=b3;end % if cut before participant steps back, then end the sample at the moment the participant steps back
            
            Dtemp=Dtemp(1:b5);Stemp=S2temp(1:b5);S2temp=S2temp(1:b5);
            
            if XS(i)==1 % car does not stop
                plot(Dtemp,S2temp,'r','Linewidth',2)
            elseif XS(i)==2 % car stops
                plot(Dtemp,S2temp,'k','Linewidth',2)
            end
        end
        for i2=1:length(V)-1 % loop over distance vector running from -200 to +200m
            TT_S(i,i2)=nanmean(S2temp(Dtemp>=V(i2) & Dtemp<V(i2+1)));
        end
        count=count+1;
        T_Distance(i)=Dtemp(b3);
        T_Speed(i)   =S2temp(b3);
        [~,b]=min(abs(abs(Dtemp)-30));
        T_Speed30m(i)=S2temp(b);
    end
end
for i=1:size(XDate,1); % plot markers
    plot(T_Distance(i),T_Speed(i),'go','markerfacecolor','g','Linewidth',3,'markersize',12);
end
plot([0 0],[-20 30],'c:','Linewidth',3)
xlabel('Distance from participant (m)');ylabel('Speed (km/h)')
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',18)
set(gcf, 'PaperPositionMode', 'manual','paperunits','inches','PaperPosition', [0 0 15 10]);
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01],'xlim',[-60 60],'ylim',[0 30],'xtick',-200:10:200);
%% Plot Figure 5 of paper
TT_SM=[nanmean(TT_S(ismember(XSC,{'A','B','C','D'}),:))
    nanmean(TT_S(ismember(XSC,{'M','N','O','P'}),:))
    nanmean(TT_S(ismember(XSC,{'I','J','K','L'}),:))
    nanmean(TT_S(ismember(XSC,{'Q','R','S','T'}),:))
    nanmean(TT_S(ismember(XSC,{'E','F','G','H'}),:))];

figure;hold on
plot(V+mean(diff(V)),TT_SM(1,:),'k','Linewidth',3)
plot(V+mean(diff(V)),TT_SM(2,:),'m','Linewidth',3)
plot(V+mean(diff(V)),TT_SM(3,:),'r:','Linewidth',3)
plot(V+mean(diff(V)),TT_SM(4,:),'b-.','Linewidth',3)
plot(V+mean(diff(V)),TT_SM(5,:),'color',[.7 .7 .7],'Linewidth',3)
plot([0 0],[-20 30],'c:','Linewidth',3)
xlabel('Distance (m)','FontSize',24,'FontName','Arial');ylabel('Speed (km/h)','FontSize',24,'FontName','Arial')
legend('TV: Manual - No signs - Attentive driver', 'AV: Joystick - No signs - Newspaper driver','AVM: Joystick - Hood & door signs - Inattentive driver','AVR: Joystick - Roof sign - Inattentive driver','TVJ: Joystick - No signs - Attentive driver','location','north')
h=findobj('FontName','Helvetica');
set(h,'FontSize',18,'Fontname','Arial')
set(gca, 'LooseInset', [0.01 0.01 0.01 0.01],'xlim',[-60 60],'ylim',[6 24]);
%%
TSTM_NaN=TSTM;TSTM_NaN(TSTM_NaN<0)=NaN;
[P_Distance,P_Speed,P_Speed30m]=deal(NaN(24,5));
[P_TimeOfDay_all16,P_Distance_all16,P_Speed_all16,P_Speed30m_all16,P_Time_all16]=deal(NaN(24,20));
T_Time=T_Distance./(T_Speed/3.6);T_Time(T_Time==-inf)=NaN; % Calculate time @ critical gap (in seconds) from GPS Distance and GPS Speed
T_Distance=abs(T_Distance);
T_Time=abs(T_Time);
for i=1:24 % loop over participants
        P_TimeOfDay_all16(i,:)=[nanmean(TSTM_NaN(ismember(XSC,{'A'}) & ismember(XPP,i))) ... % TV (manual)
        nanmean(TSTM_NaN(ismember(XSC,{'B'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'C'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'D'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'M'}) & ismember(XPP,i))) ...  % AV newspaper (joystick)
        nanmean(TSTM_NaN(ismember(XSC,{'N'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'O'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'P'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'I'}) & ismember(XPP,i))) ... % AV hood & door (joystick)
        nanmean(TSTM_NaN(ismember(XSC,{'J'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'K'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'L'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'Q'}) & ismember(XPP,i))) ... % AV roof (joystick)
        nanmean(TSTM_NaN(ismember(XSC,{'R'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'S'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'T'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'E'}) & ismember(XPP,i))) ... TV (joystick)
        nanmean(TSTM_NaN(ismember(XSC,{'F'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'G'}) & ismember(XPP,i))) ...
        nanmean(TSTM_NaN(ismember(XSC,{'H'}) & ismember(XPP,i)))];
  
        P_Distance_all16(i,:)=[nanmean(T_Distance(ismember(XSC,{'A'}) & ismember(XPP,i))) ... % TV (manual)
        nanmean(T_Distance(ismember(XSC,{'B'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'C'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'D'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'M'}) & ismember(XPP,i))) ...  % AV newspaper (joystick)
        nanmean(T_Distance(ismember(XSC,{'N'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'O'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'P'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'I'}) & ismember(XPP,i))) ... % AV hood & door (joystick)
        nanmean(T_Distance(ismember(XSC,{'J'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'K'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'L'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'Q'}) & ismember(XPP,i))) ... % AV roof (joystick)
        nanmean(T_Distance(ismember(XSC,{'R'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'S'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'T'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'E'}) & ismember(XPP,i))) ... TV (joystick)
        nanmean(T_Distance(ismember(XSC,{'F'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'G'}) & ismember(XPP,i))) ...
        nanmean(T_Distance(ismember(XSC,{'H'}) & ismember(XPP,i)))];
    
    P_Speed_all16(i,:)=[nanmean(T_Speed(ismember(XSC,{'A'}) & ismember(XPP,i))) ... % TV (manual)
        nanmean(T_Speed(ismember(XSC,{'B'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'C'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'D'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'M'}) & ismember(XPP,i))) ...  % AV newspaper (joystick)
        nanmean(T_Speed(ismember(XSC,{'N'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'O'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'P'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'I'}) & ismember(XPP,i))) ... % AV hood & door (joystick)
        nanmean(T_Speed(ismember(XSC,{'J'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'K'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'L'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'Q'}) & ismember(XPP,i))) ... % AV roof (joystick)
        nanmean(T_Speed(ismember(XSC,{'R'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'S'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'T'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'E'}) & ismember(XPP,i))) ... TV (joystick)
        nanmean(T_Speed(ismember(XSC,{'F'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'G'}) & ismember(XPP,i))) ...
        nanmean(T_Speed(ismember(XSC,{'H'}) & ismember(XPP,i)))];
    
    P_Speed30m_all16(i,:)=[nanmean(T_Speed30m(ismember(XSC,{'A'}) & ismember(XPP,i))) ... % TV (manual)
        nanmean(T_Speed30m(ismember(XSC,{'B'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'C'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'D'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'M'}) & ismember(XPP,i))) ...  % AV newspaper (joystick)
        nanmean(T_Speed30m(ismember(XSC,{'N'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'O'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'P'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'I'}) & ismember(XPP,i))) ... % AV hood & door (joystick)
        nanmean(T_Speed30m(ismember(XSC,{'J'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'K'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'L'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'Q'}) & ismember(XPP,i))) ... % AV roof (joystick)
        nanmean(T_Speed30m(ismember(XSC,{'R'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'S'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'T'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'E'}) & ismember(XPP,i))) ... TV (joystick)
        nanmean(T_Speed30m(ismember(XSC,{'F'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'G'}) & ismember(XPP,i))) ...
        nanmean(T_Speed30m(ismember(XSC,{'H'}) & ismember(XPP,i)))];
    
    P_Time_all16(i,:)=[nanmean(T_Time(ismember(XSC,{'A'}) & ismember(XPP,i))) ... % TV (manual)
        nanmean(T_Time(ismember(XSC,{'B'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'C'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'D'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'M'}) & ismember(XPP,i))) ...  % AV newspaper (joystick)
        nanmean(T_Time(ismember(XSC,{'N'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'O'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'P'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'I'}) & ismember(XPP,i))) ... % AV hood & door (joystick)
        nanmean(T_Time(ismember(XSC,{'J'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'K'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'L'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'Q'}) & ismember(XPP,i))) ... % AV roof (joystick)
        nanmean(T_Time(ismember(XSC,{'R'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'S'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'T'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'E'}) & ismember(XPP,i))) ... TV (joystick)
        nanmean(T_Time(ismember(XSC,{'F'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'G'}) & ismember(XPP,i))) ...
        nanmean(T_Time(ismember(XSC,{'H'}) & ismember(XPP,i)))];
end
ranktransform=0; % put this flag at 1 to rank-transform all variables
if ranktransform ==1
    P_Distance_all16=reshape(tiedrank(reshape(P_Distance_all16,24*20,1)),24,20);
    P_Speed_all16=reshape(tiedrank(reshape(P_Speed_all16,24*20,1)),24,20);
    P_Speed30m_all16=reshape(tiedrank(reshape(P_Speed30m_all16,24*20,1)),24,20);
    P_Time_all16=reshape(tiedrank(reshape(P_Time_all16,24*20,1)),24,20);
    Gap = reshape(tiedrank(reshape(Gap,24*20,1)),24,20);
    Stress = reshape(tiedrank(reshape(Stress,24*20,1)),24,20);
end
%%
GapO=Gap(:,[1 2 3 4 13 14 15 16 9 10 11 12 17 18 19 20 5 6 7 8]); % gap from video analysis sorted on conditon
disp(['Video analysis missing data = ' num2str(sum(sum(isnan(GapO)))) ' encounters out of 480'])
GapOi=knnimpute(GapO')'; % replaces NaNs with the corresponding value from the nearest-neighbor ROW (i.e., participant) using Euclidean distance

disp(['GPS analysis missing data = ' num2str(sum(sum(isnan(P_Distance_all16)))) ' encounters out of 480'])
P_Distance_all16i=(knnimpute(P_Distance_all16')'); % replaces NaNs with the corresponding value from the nearest-neighbor ROW (i.e., participant) using Euclidean distance

P_Speed_all16i=knnimpute(P_Speed_all16')';            % replaces NaNs with the corresponding value from the nearest-neighbor ROW (i.e., participant) using Euclidean distance
P_Speed30m_all16i=knnimpute(P_Speed30m_all16')';                  % replaces NaNs with the corresponding value from the nearest-neighbor ROW (i.e., participant) using Euclidean distance
P_Time_all16i=(knnimpute(P_Time_all16')');         % replaces NaNs with the corresponding value from the nearest-neighbor ROW (i.e., participant) using Euclidean distance

[GapOi_TimeOrdered,P_Distance_all16i_TimeOrdered]=deal(NaN(size(GapOi)));
clear temp
for i=1:24;
[~,b]=sort(P_TimeOfDay_all16(i,:));
GapOi_TimeOrdered(i,:)=GapOi(i,b);
P_Distance_all16i_TimeOrdered(i,:)=P_Distance_all16i(i,b);
end

%% Section 3.1.3 Verification of Approach Speeds
close all;clc;

X=[mean(P_Speed30m_all16i(:,1:2),2) mean(P_Speed30m_all16i(:,3:4),2) mean(P_Speed30m_all16i(:,5:6),2) mean(P_Speed30m_all16i(:,7:8),2) mean(P_Speed30m_all16i(:,9:10),2) mean(P_Speed30m_all16i(:,11:12),2) mean(P_Speed30m_all16i(:,13:14),2) mean(P_Speed30m_all16i(:,15:16),2) mean(P_Speed30m_all16i(:,17:18),2) mean(P_Speed30m_all16i(:,19:20),2)];
disp('Table 2 left: M and SD for critical gap, GPS in km/h, 30 m')
disp(round([nanmean(X)' nanstd(X)'],2))

Xl=[mean(P_Speed30m_all16i(:,1:2),2) mean(P_Speed30m_all16i(:,5:6),2) mean(P_Speed30m_all16i(:,9:10),2)  mean(P_Speed30m_all16i(:,13:14),2) mean(P_Speed30m_all16i(:,17:18),2) ]; % from left
[~,~,stats]=anova2(Xl);
multcompare(stats)

Xr=[mean(P_Speed30m_all16i(:,3:4),2) mean(P_Speed30m_all16i(:,7:8),2) mean(P_Speed30m_all16i(:,11:12),2)  mean(P_Speed30m_all16i(:,15:16),2) mean(P_Speed30m_all16i(:,19:20),2) ]; % from right
[~,~,stats]=anova2(Xr);
multcompare(stats)

disp(['In left approaches, participants drove on average ' num2str(mean(mean(Xl(:,1))-mean(Xl(:,2:5)))) ' km/h faster in the TV condition than in the AV condition'])
disp(['In right approaches, participants drove on average ' num2str(mean(mean(Xr(:,1))-mean(Xr(:,2:5)))) ' km/h faster in the TV condition than in the AV condition'])
%% Table 1 left: Critical gap (video distance measurement)
close all;clc
X=[mean(GapOi(:,1:2),2) mean(GapOi(:,3:4),2) mean(GapOi(:,5:6),2) mean(GapOi(:,7:8),2) mean(GapOi(:,9:10),2) mean(GapOi(:,11:12),2) mean(GapOi(:,13:14),2) mean(GapOi(:,15:16),2) mean(GapOi(:,17:18),2) mean(GapOi(:,19:20),2)];
disp('Table 1 left: M and SD for critical gap video analysis')
disp(round([nanmean(X)' nanstd(X)'],2))

Xl=[mean(GapOi(:,1:2),2) mean(GapOi(:,5:6),2) mean(GapOi(:,9:10),2)  mean(GapOi(:,13:14),2) mean(GapOi(:,17:18),2) ]; % from left
[~,~,stats]=anova2(Xl);
multcompare(stats)


Xr=[mean(GapOi(:,3:4),2) mean(GapOi(:,7:8),2) mean(GapOi(:,11:12),2)  mean(GapOi(:,15:16),2) mean(GapOi(:,19:20),2) ]; % from right[~,~,stats]=anova2(Xr);
[~,~,stats]=anova2(Xr);
multcompare(stats)

%% Table 1 right: Critical gap (GPS distance measurement)
clc;close all
X=[mean(P_Distance_all16i(:,1:2),2) mean(P_Distance_all16i(:,3:4),2) mean(P_Distance_all16i(:,5:6),2) mean(P_Distance_all16i(:,7:8),2) mean(P_Distance_all16i(:,9:10),2) mean(P_Distance_all16i(:,11:12),2) mean(P_Distance_all16i(:,13:14),2) mean(P_Distance_all16i(:,15:16),2) mean(P_Distance_all16i(:,17:18),2) mean(P_Distance_all16i(:,19:20),2)];
disp('Table 1 right: M and SD for critical gap, GPS (m)')
disp(round([nanmean(X)' nanstd(X)'],2))

Xl=[mean(P_Distance_all16i(:,1:2),2) mean(P_Distance_all16i(:,5:6),2) mean(P_Distance_all16i(:,9:10),2)  mean(P_Distance_all16i(:,13:14),2) mean(P_Distance_all16i(:,17:18),2) ]; % from left
[~,~,stats]=anova2(Xl);
multcompare(stats)


Xr=[mean(P_Distance_all16i(:,3:4),2) mean(P_Distance_all16i(:,7:8),2) mean(P_Distance_all16i(:,11:12),2)  mean(P_Distance_all16i(:,15:16),2) mean(P_Distance_all16i(:,19:20),2) ]; % from right
[~,~,stats]=anova2(Xr);
multcompare(stats)

%% Table 2 left: Critical gap speed (GPS speed measurement)
close all;clc
X=[mean(P_Speed_all16i(:,1:2),2) mean(P_Speed_all16i(:,3:4),2) mean(P_Speed_all16i(:,5:6),2) mean(P_Speed_all16i(:,7:8),2) mean(P_Speed_all16i(:,9:10),2) mean(P_Speed_all16i(:,11:12),2) mean(P_Speed_all16i(:,13:14),2) mean(P_Speed_all16i(:,15:16),2) mean(P_Speed_all16i(:,17:18),2) mean(P_Speed_all16i(:,19:20),2)];
disp('Table 2 left: M and SD for critical gap, GPS in km/h')
disp(round([nanmean(X)' nanstd(X)'],2))

Xl=[mean(P_Speed_all16i(:,1:2),2) mean(P_Speed_all16i(:,5:6),2) mean(P_Speed_all16i(:,9:10),2)  mean(P_Speed_all16i(:,13:14),2) mean(P_Speed_all16i(:,17:18),2) ]; % from left
[~,~,stats]=anova2(Xl);
multcompare(stats)


Xr=[mean(P_Speed_all16i(:,3:4),2) mean(P_Speed_all16i(:,7:8),2) mean(P_Speed_all16i(:,11:12),2)  mean(P_Speed_all16i(:,15:16),2) mean(P_Speed_all16i(:,19:20),2) ]; % from right
[~,~,stats]=anova2(Xr);
multcompare(stats)

%% Table 2 right: Critical gap time (GPS distance measurement)
X=[mean(P_Time_all16i(:,1:2),2) mean(P_Time_all16i(:,3:4),2) mean(P_Time_all16i(:,5:6),2) mean(P_Time_all16i(:,7:8),2) mean(P_Time_all16i(:,9:10),2) mean(P_Time_all16i(:,11:12),2) mean(P_Time_all16i(:,13:14),2) mean(P_Time_all16i(:,15:16),2) mean(P_Time_all16i(:,17:18),2) mean(P_Time_all16i(:,19:20),2)];
disp('Table 2 right: M and SD for critical gap, GPS in s')
disp(round([nanmean(X)' nanstd(X)'],2))
Xl=[mean(P_Time_all16i(:,1:2),2) mean(P_Time_all16i(:,5:6),2) mean(P_Time_all16i(:,9:10),2)  mean(P_Time_all16i(:,13:14),2) mean(P_Time_all16i(:,17:18),2) ]; % from left
[~,~,stats]=anova2(Xl);
multcompare(stats)


Xr=[mean(P_Time_all16i(:,3:4),2) mean(P_Time_all16i(:,7:8),2) mean(P_Time_all16i(:,11:12),2)  mean(P_Time_all16i(:,15:16),2) mean(P_Time_all16i(:,19:20),2) ]; % from right
[~,~,stats]=anova2(Xr);
multcompare(stats)

%% Table 3: Stress
StressO=Stress(:,[1 2 3 4 13 14 15 16 9 10 11 12 17 18 19 20 5 6 7 8]); % gap from video analysis sorted on condition
temp=find(sum(isnan(StressO'))>=18); % 3 participants have missing data
temp2=find(sum(isnan(StressO'))<18); % 21 participants are kept
StressOi=NaN(size(StressO));
disp(['Stress missing data = ' num2str(sum(sum(isnan(StressO(temp2,:))))) ' encounters out of 420'])
StressOi(temp2,:)=knnimpute(StressO(temp2,:)')';

X=[mean(StressOi(:,1:2),2) mean(StressOi(:,3:4),2) mean(StressOi(:,5:6),2) mean(StressOi(:,7:8),2) mean(StressOi(:,9:10),2) mean(StressOi(:,11:12),2) mean(StressOi(:,13:14),2) mean(StressOi(:,15:16),2) mean(StressOi(:,17:18),2) mean(StressOi(:,19:20),2)];
disp('Table 3: M and SD for Stess on a scale from 0 to 10')
disp(round([nanmean(X)' nanstd(X)'],2))
Xl=[mean(StressOi(:,1:2),2) mean(StressOi(:,5:6),2) mean(StressOi(:,9:10),2)  mean(StressOi(:,13:14),2) mean(StressOi(:,17:18),2) ]; % from left
Xl(temp,:)=[];
[pl,~,stats]=anova2(Xl);
multcompare(stats)


Xr=[mean(StressOi(:,3:4),2) mean(StressOi(:,7:8),2) mean(StressOi(:,11:12),2)  mean(StressOi(:,15:16),2) mean(StressOi(:,19:20),2) ]; % from right
Xr(temp,:)=[];
[pr,~,stats]=anova2(Xr);
multcompare(stats)

%% Trust (Table 4)
disp('Table 4: Self-reported trust')
disp(round([nanmean(Trust)' nanstd(Trust)'],2))
%% Sensation seeking (Table 5)
disp('Table 5: Self-reported sensation seeking')
disp(round([nanmean(SSS)' nanstd(SSS)'],2))
%% Correlation matrix Table 6
X=[Age Gender nanmean(GapOi,2) nanmean(P_Distance_all16i,2) nanmean(P_Speed_all16i,2) nanmean(P_Time_all16i,2) nanmean(StressOi,2) nanmean(Trust,2) nanmean(SSS,2)];
temp=find(X(:,end)==4);X(temp,4)=NaN;
M='1.Age 2.Gender 3.DisVid 4.DisGPS 5.SpeedGPS 6.TimeGPS 7.Stess 8.Trust 9.SSS';
[c,p]=corr(X,'rows','pairwise');
printmat(round(c,2),'Correlation matrix (Table 6)', M,M)

%%
figure;hold on
plot(mean(P_Distance_all16i_TimeOrdered),'ko-','markersize',12,'Linewidth',3);
plot([1 20],polyval(polyfit(1:20,mean(P_Distance_all16i_TimeOrdered),1),[1 20]),'k:','Linewidth',2)
plot(mean(GapOi_TimeOrdered),'s-','markersize',12,'color',[.5 .5 .5],'Linewidth',3);
plot([1 20],polyval(polyfit(1:20,mean(GapOi_TimeOrdered),1),[1 20]),':','color',[.5 .5 .5],'Linewidth',2)
set(gca,'LooseInset', [0.01 0.01 0.01 0.01],'ylim',[0 30],'xlim',[.8 20.2],'xtick',1:20,'xticklabel',{'1st' '2nd' '3rd','4th','5th','6th','7th','8th','9th','10th','11th','12th','13th','14th','15th','16th','17th','18th','19th','20th'});
grid on
legend('GPS-based measurement','GPS-based measurement, linear fit','Video-based measurement','Video-based measurement, linear fit','location','southeast')
xlabel('Trial number')
ylabel('Critical gap distance (m)')
h=findobj('FontName','Helvetica');
set(h,'FontSize',18,'Fontname','Arial')
clear table
%% Self-reported visual cues
[~,~,raw]=xlsread('Visual_factors.xlsx',1,'B2:U73');
d={    '2 lanes'
    'Avoid sudden braking'
    'Car approaching'
    'Car close to the sidewalk'
    'Car noise'
    'Car not stopping'
    'Car stopping'
    'Car stopping or not'
    'Contact with the driver'
    'Distance'
    'Distracted driver'
    'Distracted pedestrian'
    'Doubt car stopping or  not'
    'Doubt car stopping or not'
    'Doubt eye contact with driver'
    'Doubts car stopping or not'
    'Driver eating an apple'
    'Driver reading a newspaper'
    'Driver reading a newspaper'
    'Eye contact with driver'
    'Eye contact with driver '
    'Eye contact with the driver'
    'Getting used to the experiment'
    'Hands on the wheel'
    'No eye contact with driver'
    'No hands on the wheel'
    'No other cars on the road'
    'No self-driving signs'
    'No step back: driver reading a newspaper'
    'Not enough time to cross'
    'Not in a hurry'
    'Not sure (speed)'
    'Perspective'
    'Reaction of the driver'
    'Same side of the road'
    'Self-driving signs'
    'Small car deviation'
    'Something placed on the front of the car'
    'Sped'
    'Speed'
    'Speed'
    'Strange driving behaviour'
    'Strange noise'
    'Time to cross the road'
    'Wait until sign was readable'
    'Weather'
    'Wind'
    'distance'
    'eye contact with driver'
    'self-driving signs'
    'speed'};
NC=NaN(length(d),20);
for i2=1:20; % loop over 20 scenarions
    for i=1:length(d)
        NC(i,i2)=sum(strcmp(raw(:,i2),d(i)));
    end
end
disp([sum(NC(:,1:4),2) sum(NC(:,13:16),2) sum(NC(:,9:12),2) sum(NC(:,17:20),2) sum(NC(:,5:8),2)]) % TV, AV, AVM, AVR, AVJ
disp('Number of opportunities for comments = 20 x 24 = 480')
disp('No data for 81 encounters, so 399 interviews')
disp(['Participants reported a total of ' num2str(sum(sum(NC))) ' factors'])
disp(['Speed was reported a total of ' num2str(sum(NC(40,:))) ' times, out of a total of ' num2str(sum(sum(NC))) ])
disp(['Self-driving signs was reported a total of ' num2str(sum(NC(36,:))) ' times, out of a total of ' num2str(sum(sum(NC(:,[9:12 17:20]),2))) ])
disp(['Newspaper was reported a total of ' num2str(sum(NC(18,:))) ' times, out of a total of ' num2str(sum(sum(NC(:,13:16),2))) ])
disp(['Eye contact was reported a total of ' num2str(sum(sum(NC([9 15 20 25 49],:)))) ' times, out of a total of ' num2str(sum(sum(NC))) ])
disp(['Hands was reported a total of ' num2str(sum(sum(NC([24 26],:)))) ' times, out of a total of ' num2str(sum(sum(NC))) ])
disp(['Weather was reported a total of ' num2str(sum(sum(NC([46 47],:)))) ' times, out of a total of ' num2str(sum(sum(NC))) ])
disp(['Vehicle stopping or not stopping was reported a total of ' num2str(sum(sum(NC([6 7 8 14 16],:)))) ' times, out of a total of ' num2str(sum(sum(NC))) ])
disp(['Small lateral deviations was reported a total of ' num2str(sum(sum(NC(37,:)))) ' times, out of a total of ' num2str(sum(sum(NC))) ])
disp(['Approaching direction was reported a total of ' num2str(sum(sum(NC(1,:)))) ' times, out of a total of ' num2str(sum(sum(NC))) ])